<template>
  <div>
    <h1>Démo Store avec Vuex</h1>
    <div v-for="(item, index) in items" :key="index" :class="item.class">
      <span class="cart-item-name">{{ item.name }}</span>
      <span class="cart-item-price">{{ item.price }}€</span>
    </div>
    <br />
    <br />
    <form @submit.prevent="submit">
      <input 
        v-model="newItem.name" 
        type="text" 
        placeholder="Nom de l'article" 
      />
      <br />
      <input 
        v-model="newItem.price" 
        type="number" 
        placeholder="Prix de l'article"         
      />
      <br />
      <button type="submit">Ajouter un article</button>
    </form>
  </div>
</template>

<script>
import { mapActions } from 'vuex'

export default {
  name: 'StoreDemo',

  data: function () {
    return {
      newItem: {}
    }
  },

  computed: {
    items () {
      return this.$store.getters.ITEMS;
    }
  },

  methods: {

    ...mapActions({
      addItem: 'ADD_ITEM' // attacher `this.addItem()` à `this.$store.dispatch('ADD_ITEM')`
    }),
    
    submit () {
      const { name, price } = this.newItem;

      if (!name) {
        return alert('Veuillez indiquez le nom de l\'article');
      }

      if (!price) {
        return alert('Veuillez indiquez le prix de l\'article');
      }

      // this.$store.dispatch('ADD_ITEM', this.newItem);
      this.addItem(this.newItem)
      this.newItem = {};
    }
  }
}
</script>

<style lang="scss" scoped>
  .cart-item {
    &-name {
      margin-right: 0.5rem;
    }

    &-price {
      font-weight: bold;
    }
  }
</style>
